/*
 * @(#) $Id: CompositeMenuAppShell.java 8540 2011-09-23 08:56:00Z laslovd $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package at.spardat.xma.appshell;

import org.eclipse.swt.widgets.Composite;

import at.spardat.xma.component.ComponentClient;

/**
 * Base class for AppSehells that uses non-drop-down menus in a composite (like an SWT Tree).  
 * @author s4709  
 * @since 4.1.0
 */
public abstract class CompositeMenuAppShell extends ContextAppShell {

    /**
     * Initializes the application shell.
     *
     * @param component the Component containing the DialogPage.
     * @param stateless indicating if this page is stateless on the server.
     * @param style The SWT-Style for the Shell of the DialogPage.
     * @throws IllegalArgumentException if component is null.
     */
    public CompositeMenuAppShell ( ComponentClient component, boolean stateless, int style ) {
        super(component,stateless,style);
    }

    /**
     * Get the swt-composite for holding the menu items.
     * It will be filled completely with a tree containing the menu items.
     * @return the composite for the menu.
     */
    abstract protected Composite getMenuComp ();

}
