/*
 * @(#) $Id: MultiMenuAppShell.java 8604 2011-10-21 17:25:10Z laslovd $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package at.spardat.xma.appshell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import at.spardat.xma.component.ComponentClient;

// TODO: comment me
public abstract class MultiMenuAppShell extends CompositeMenuAppShell {

    public MultiMenuAppShell ( ComponentClient component, boolean stateless, int style, final int tabAlignment ) {
        super(component,stateless,style);
        addDelegate(new MenuAppShellDelegate() {
            public ITask createRootTask(IMenuItem rootMenu) { return createDropDownMenuRootTask(rootMenu); }
            public Composite getClientComposite() { return getDropDownMenuClientComposite(); } 
            protected Composite getContextComp() { return getDropDownContextComp(); } 
        });
        addDelegate(new TreeMenuAppShellDelegate() {
            public ITask createRootTask(IMenuItem rootMenu) { return createTreeMenuRootTask(rootMenu); }
            protected Composite getMenuComp() { return getTreeMenuComp(); }
            public Composite getClientComposite() { return getTreeMenuClientComposite(); } 
            protected Composite getContextComp() { return getTreeContextComp(); } 
        });
        addDelegate(new TabAppShellDelegate(tabAlignment) {
            public ITask createRootTask(IMenuItem rootMenu) { return createTabMenuRootTask(rootMenu); }
            protected Composite getMenuComp() { return getTabMenuComp(); }
            public Composite getClientComposite() { return getTabMenuClientComposite(); } 
            protected Composite getContextComp() { return getTabContextComp(); } 
        });
    }
    
    public MultiMenuAppShell ( ComponentClient component, boolean stateless, int style ) {
        this(component,stateless,style,SWT.LEFT_TO_RIGHT);
    }
    
    public Composite getClientComposite () {
        return null;
    }
    
    protected Composite getTabMenuClientComposite () {
        return getClientComposite(); 
    }

    protected Composite getTreeMenuClientComposite () {
        return getClientComposite(); 
    }

    protected Composite getDropDownMenuClientComposite () {
        return getClientComposite(); 
    }

    protected ITask createDropDownMenuRootTask ( IMenuItem rootMenu ) {
        return null;
    }

    protected ITask createTreeMenuRootTask ( IMenuItem rootMenu ) {
        return null;
    }

    protected ITask createTabMenuRootTask ( IMenuItem rootMenu ) {
        return null;
    }

    protected Composite getTreeMenuComp () {
        return null;
    }

    protected Composite getTabMenuComp () {
        return null;
    }

    protected Composite getDropDownContextComp() {
        return null;
    }

    protected Composite getTreeContextComp() {
        return null;
    }

    protected Composite getTabContextComp() {
        return null;
    }

    final protected Composite getMenuComp () {
        return null;
    }

    final protected Composite getContextComp() {
        return null;
    }

    final public ITask createRootTask ( IMenuItem rootMenu ) {
        return null;
    }
}
