/*******************************************************************************
 * Copyright (c) 2003, 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

// @(#) $Id:  $
package at.spardat.xma.mdl.paging;
/**
 * The implementors of this interface are attached to an {@link IPagingWMClient} and
 * responsible to update the corresponding {@link at.spardat.xma.mdl.table.ITableWM}
 * whenever its method {@link #reload(int, int)} is called.
 * You register an implementation of this interface to the paging model using
 * {@link IPagingWMClient#setPagingListener(PagingListener)}. Every time the user
 * clicks on a navigation button of the paging control, the listeners
 * {@link #reload(int, int)} method will be called. In this method you will typically
 * make an RPC to the server side in which you make a query to the database which
 * restricts its result set to the rows between offset and offset+pagesize.
 * You can access all information of the pagin model on server side, too.
 * E.g. using {@link IPagingWM#getOffset()}, {@link IPagingWM#getPageSize()},
 * {@link IPagingWM#getTable()}, ...
 *
 * @author gub
 * @since 2.3.0
 */
public interface PagingListener {
    /**
     * Reload the given page of data into the table attached to the {@link IPagingWM}
     * this listener attached.
     * @param offset offset of the first data object to show
     * @param pagesize number of data objects to show
     */
    public void reload(int offset,int pagesize);
}
