/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

/*
 * Created on 20.06.2003
 *
 * 
 * 
 */
package at.spardat.xma.security;

import javax.security.auth.callback.Callback;

/**
 * This class can be used by LoginModules to request a challenge.
 * {@link XMACallbackHandler} supports this callback.
 * 
 * @author s2877
 */
public class ChallengeCallback implements Callback {
    String challenge;
    
    /**
     * Get the challenge as set by the callback handler.
     * @return the challenge as set by the callback handler.
     */
    public String getChallenge() {
        return challenge;
    }

    /**
     * Set the challenge. This method is intended to be used by the callback handler.
     * @param string the challenge to set.
     */
    public void setChallenge(String string) {
        challenge = string;
    }

}
